Index: CMT/v1r25-branch/source/cmt_parser.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_parser.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_parser.cxx	(revision 664)
@@ -1891,38 +2160,71 @@
     CmtSystem::putenv ("CMTBCAST", "");
 
-  for (i = 0; i < uses.size (); i++)
+  for (int i = 0; i < uses.size (); i++)
     {
       const cmt_string& s = uses[i];
       const cmt_string& v = versions[i];
       const cmt_string& p = packages[i];
+      const int use_index = use_indexes[i];
+
+      const Use* use = use_index >= 0 ? Uses[use_index] : &(Use::current ());
+      const Project* up = use->get_project ();
+
       cmt_string cmtpath;
 
       bool ok = true;
-      bool selected = true;
+      bool selected = global ? true : false;
       bool excluded = false;
 
-      /**
-	 Ensure that the current package is not skipped
-	 due to symlinks in the paths
-       */
-      //      if (path_selections.size () > 0)
-      if (path_selections.size () > 0 && s != curuse)
+      ok = selected;
+      if (path_selections.size () > 0)
         {
           selected = false;
-
           for (int j = 0; j < path_selections.size (); j++)
             {
-              const cmt_string& sel = path_selections[j];
-              
-              if (s.find (sel) != cmt_string::npos) 
-                {
-		  cmtpath = sel;
-                  selected = true;
-                  break;
-                }
-            }
-
+              const Project* sp = path_selections[j];
+	      if (sp)
+		{
+		  if (up)
+		    {
+		      if (up == sp)
+			{
+			  cmtpath = sp->get_cmtpath ();
+			  selected = true;
+			  break;
+			}
+		    }
+		  else
+		    {
+		      if (use->get_realpath ().find (sp->get_cmtpath_real ()) == 0)
+			{
+			  cmtpath = sp->get_cmtpath ();
+			  selected = true;
+			  break;
+			}
+		    }
+		}
+	      else if (use == &(Use::current ()))
+		{
+		  // means that we want Use::current ()
+		  // cmtpath = sp->get_cmtpath ();
+		  if (up)
+		    cmtpath = up->get_cmtpath ();
+		  else
+		    cmtpath = "";
+		  selected = true;
+		  break;
+		}
+	      // const cmt_string& sel = path_selections[j];
+	      // if (s.find (sel) != cmt_string::npos) 
+//                 {
+// 		  cmtpath = sel;
+//                   selected = true;
+//                   break;
+//                 }
+	    }
           ok = selected;
         }
+      else if (up)
+	cmtpath = up->get_cmtpath ();
 
       if (ok)
@@ -1960,5 +2262,4 @@
         }
 
-
       if (ok)
         {
@@ -1974,4 +2275,31 @@
                   break;
                 }
+            }
+
+          if (excluded) ok = false;
+        }
+
+      if (ok)
+        {
+          excluded = false;
+          for (int j = 0; j < path_exclusions.size (); j++)
+            {
+              const Project* sp = path_exclusions[j];
+	      if (up)
+		{
+		  if (up == sp)
+		    {
+		      excluded = true;
+		      break;
+		    }
+		}
+	      else
+		{
+		  if (use->get_realpath ().find (sp->get_cmtpath_real ()) == 0)
+		    {
+		      excluded = true;
+		      break;
+		    }
+		}
             }
 
@@ -2021,4 +2349,5 @@
         }
 
+      /*
       if (cmtpath == "")
         {
@@ -2026,4 +2355,5 @@
 	  cmtpath = Project::find_in_cmt_paths (sel);
         }
+      */
 
       cmt_string cmd = command;
@@ -2041,24 +2371,31 @@
       static const cmt_string empty_string;
       static const cmt_string fs = CmtSystem::file_separator ();
-      cmt_string offset = s;
-      offset.replace (cmtpath, empty_string);
-      if (offset[0] == CmtSystem::file_separator ())
-	{
-	  offset.replace (fs, empty_string);
-	}
-      CmtSystem::dirname (offset, offset);
-
-      cmt_string n;
-      CmtSystem::basename (offset, n);
-      if (n == p)
-	{
+      cmt_string offset;
+      if (cmtpath.size ())
+	{
+	  offset = s;
+	  offset.replace (cmtpath, empty_string);
+	  if (offset[0] == CmtSystem::file_separator ())
+	    {
+	      offset.replace (fs, empty_string);
+	    }
 	  CmtSystem::dirname (offset, offset);
+	  
+	  cmt_string n;
+	  CmtSystem::basename (offset, n);
+	  if (n == p)
+	    {
+	      CmtSystem::dirname (offset, offset);
+	    }
+	  else
+	    {
+	      CmtSystem::dirname (offset, offset);
+	      CmtSystem::dirname (offset, offset);
+	    }
 	}
       else
 	{
-	  CmtSystem::dirname (offset, offset);
-	  CmtSystem::dirname (offset, offset);
-	}
-
+	  offset = use->real_path;
+	}
       cmd.replace_all (offset_template, offset);
 
@@ -2067,5 +2404,5 @@
     {
       cout << "#--------------------------------------------------------------" << endl;
-      cout << "# Now trying [" << cmd << "] in " << s << " (" << i+1 << "/" << uses.size () 
+      cout << "# " << p << " " << v << " " << offset << ": Now trying [" << cmd << "] in " << s << " (" << i+1 << "/" << uses.size () 
            << ")" << endl;
       cout << "#--------------------------------------------------------------" << endl;
@@ -2904,24 +3241,50 @@
     }
 
-  static CmtSystem::cmt_string_vector tags;
+  //  static CmtSystem::cmt_string_vector tags;
 
   if (action_build_constituents_config != get_action ())
-    CmtSystem::split (Me.m_extra_tags, " \t,", tags);
-
-  for (int i = 0; i < tags.size (); i++)
-    {
-      const cmt_string& t = tags[i];
-
-      tag = Tag::find (t);
-      if (tag == 0) continue;
-
-      if (!Tag::check_tag_used (tag) && !Symbol::check_tag_used (tag)) 
-	{
-	  CmtMessage::warning ("The tag " + t + " is not used in any tag expression. Please check spelling");
-	  //	  cerr << "#CMT> The tag " << t << " is not used in any tag expression. Please check spelling" << endl;
-	}
-    }
-
-  Symbol::check_all_paths ();
+    {
+    //    CmtSystem::split (Me.m_extra_tags, " \t,", tags);
+
+    //  for (int i = 0; i < tags.size (); i++)
+      //    {
+      //      const cmt_string& t = tags[i];
+      for (int i = 0; i < Me.m_extra_tags.size (); i++)
+	{
+	  const cmt_string& t = Me.m_extra_tags[i];
+	  tag = Tag::find (t);
+	  if (tag == 0) continue;
+	  if (!Tag::check_tag_used (tag) && !Symbol::check_tag_used (tag)) 
+	    {
+	      CmtMessage::warning ("The tag " + t + " is not used in any tag expression. Please check spelling");
+	    }
+	}
+      for (int i = 0; i < Me.m_tags.size (); i++)
+	{
+	  const cmt_string& t = Me.m_tags[i];
+	  tag = Tag::find (t);
+	  if (tag == 0) continue;
+	  if (!Tag::check_tag_used (tag) && !Symbol::check_tag_used (tag)) 
+	    {
+	      CmtMessage::warning ("The tag " + t + " is not used in any tag expression. Please check spelling");
+	    }
+	}
+      for (int i = 0; i < Me.m_tags_add.size (); i++)
+	{
+	  const cmt_string& t = Me.m_tags_add[i];
+	  tag = Tag::find (t);
+	  if (tag == 0) continue;
+	  if (!Tag::check_tag_used (tag) && !Symbol::check_tag_used (tag)) 
+	    {
+	      CmtMessage::warning ("The tag " + t + " is not used in any tag expression. Please check spelling");
+	    }
+	}
+    }
+
+  if (action_setup != get_action () ||
+      Requirements == ap.mode)
+    // PathBuilder::filter_path_value is called
+    // for each path in Symbol::print
+    Symbol::check_all_paths ();
 
   env = CmtSystem::getenv ("CMTSITE");
@@ -2940,5 +3303,4 @@
     {
       CmtMessage::warning ("The CMTSITE value " + env + " is not used in any tag expression. Please check spelling");
-      //      cerr << "#CMT> The CMTSITE value " << env << " is not used in any tag expression. Please check spelling" << endl;
     }
 
@@ -4323,7 +4685,9 @@
       break;
     case Requirements :
+      /*
       CmtSystem::cmt_string_vector flags;
       get_cmt_flags (flags);
       cout << "\n# CMTFLAGS: -without_cmt";
+      cout << " -without_projects" ;
       for (int i = 0; i < flags.size (); i++)
 	{
@@ -4332,11 +4696,126 @@
 	  else if (flags[i] == "-with_cmt")
 	    cout << " -without_cmt";
+	  else if (flags[i] == "-without_projects")
+	    cout << " -with_projects";
+	  else if (flags[i] == "-with_projects")
+	    cout << " -without_projects";
 	  else
 	    cout << " " << flags[i]; 
 	}
       cout << endl;
+      */
       break;
-    }
-  print (ap.mode);
+    default:
+      break;
+    }
+
+  ostringstream os;
+  ostringstream oh;
+  bool reset (false);
+  CmtSystem::cmt_string_vector flags;
+  cmt_string strip_path_flag;
+  bool strip_path (false);
+
+  bool strip_saved (get_strip_path ());
+  bool access_saved (Cmt::get_env_access ());
+
+  switch (ap.mode)
+    {
+    case Requirements :
+
+      get_cmt_flags (flags);
+      for (int i = 0; i < flags.size (); i++)
+	{
+	  if (flags[i] == "-no_strip_path")
+	    strip_path_flag = "-no_strip_path";
+	  else if (flags[i] == "-strip_path")
+	    strip_path_flag = "-strip_path";
+	}
+      if (strip_path_flag != "-no_strip_path" &&
+	  !get_strip_path ())
+	reset = Symbol::set_strip_path (true);
+
+      if (get_strip_path () || reset)
+	strip_path = true;
+      else
+	strip_path = false;
+
+      Cmt::set_env_access (false);
+
+      print (ap.mode, os);
+
+      if (CmtError::get_last_error_code () == CmtError::warning &&
+	  (get_strip_path () || reset))
+	{
+	  reset = Symbol::set_strip_path (false);
+	  if (reset)
+	    {
+	      strip_path = false;
+
+	      CmtError::print ();
+	      CmtError::clear ();
+
+	      if (Cmt::get_debug ())
+		{
+		  cerr << "|Cmt::do_setup> Failure with:\n" << os.str ()
+		       << "|Cmt::do_setup> Trying again." << endl;
+		}
+
+	      // Try again
+	      os.str ("");
+	      print (ap.mode, os);
+	    }
+	}
+
+      if (reset) Symbol::set_strip_path (strip_saved);
+      Cmt::set_env_access (access_saved);
+
+      //get_cmt_flags (flags);
+      oh << "\n# CMTFLAGS:"
+	" -without_cmt"
+	" -without_projects"
+	//" -strip_path"
+	;
+      for (int i = 0; i < flags.size (); i++)
+	{
+	  if (flags[i] == "-without_cmt")
+	    oh << " -with_cmt";
+	  else if (flags[i] == "-with_cmt")
+	    oh << " -without_cmt";
+	  else if (flags[i] == "-without_projects")
+	    oh << " -with_projects";
+	  else if (flags[i] == "-with_projects")
+	    oh << " -without_projects";
+	  /*
+	  else if (flags[i] == "-no_strip_path")
+	    oh << " -strip_path";
+	  else if (flags[i] == "-strip_path")
+	    oh << " -no_strip_path";
+	  */
+	  else if (flags[i] == "-no_strip_path" ||
+		   flags[i] == "-strip_path")
+	    continue;
+	  else
+	    oh << " " << flags[i]; 
+	}
+      //if (reset) oh << " -strip_path";
+      if (strip_path)
+	oh << " -no_strip_path";
+      else
+	oh << " -strip_path";
+      oh << endl;
+
+      cout << oh.str ();
+      cout << os.str ();
+
+      break;
+
+    default:
+
+      print (ap.mode);
+
+      break;
+    }
+
   switch (ap.mode)
     {
@@ -4476,9 +4955,11 @@
 
   Use& use = Use::current();    
+  /*
   use.get_cmtpath_and_offset (cmtpath, offset);
 
   Project* p = Project::find_by_cmtpath (cmtpath);
-
-  cout << p->get_author () << endl;
+  */
+  if (const Project* p = use.get_project ())
+    cout << p->get_author () << endl;
 }
 
@@ -4503,7 +4984,9 @@
   ClientCollector collector (package, version);
 
+  /*
   clear     ();
   //  configure ();
   configure (ap);
+  */
 
   cout << "# ----------- Clients of " << package
@@ -5164,9 +5647,10 @@
 
 //----------------------------------------------------------
+/*
 ActionType Cmt::get_action ()
 {
   return (Me.m_action);
 }
-
+*/
 /*
   const CmtSystem::cmt_string_vector& Cmt::get_cmt_path ()
@@ -5185,5 +5669,5 @@
   }
 */
-
+ /*
 const cmt_string& Cmt::get_cmt_home ()
 {
@@ -5205,5 +5689,5 @@
   return (Me.m_current_dir);
 }
-
+*/
 const cmt_string Cmt::get_current_dir_real ()
 {
@@ -5213,10 +5697,10 @@
   return (Me.m_current_dir);
 }
-
+/*
 const cmt_string& Cmt::get_current_package ()
 {
   return (Me.m_current_package);
 }
-
+*/
 const cmt_string& Cmt::get_current_path ()
 {
@@ -5233,5 +5717,5 @@
   return (Me.m_current_offset);
 }
-
+/*
 AccessMode Cmt::get_current_access ()
 {
@@ -5248,15 +5732,22 @@
   return (Me.m_current_style);
 }
-
+*/
 const cmt_string& Cmt::get_current_version ()
 {
   return (Me.m_current_version);
 }
-
+/*
 const cmt_string& Cmt::get_current_target ()
 {
   return (Me.m_current_target);
 }
-
+*/
+/*
+const CmtSystem::cmt_string_vector& Cmt::get_tags_remove ()
+{
+  return (Me.m_tags_remove);
+}
+*/
+ /*
 bool Cmt::get_debug ()
 {
@@ -5283,5 +5774,5 @@
   return (Me.m_recursive);
 }
-
+ */
 CmtScopeFilteringMode Cmt::get_scope_filtering_mode ()
 {
@@ -5297,9 +5788,10 @@
 
 //----------------------------------------------------------
+/*
 bool Cmt::get_all_sets_done ()
 {
   return (Me.m_all_sets_done);
 }
-
+*/
 //----------------------------------------------------------
 void Cmt::get_cmt_flags (CmtSystem::cmt_string_vector& flags)
@@ -5421,9 +5913,11 @@
 void Cmt::guess_current_project ()
 {
+  if (!m_cmt_context.m_use_projects) return;
+
   Log;
 
   log << "guess_current_project" << log_endl;
 
-  cmt_string here = CmtSystem::pwd ();
+  //  cmt_string here = CmtSystem::pwd ();
 
   Use& use = Use::current();
@@ -5438,4 +5932,5 @@
     //  if (Project::find_in_cmt_paths (Me.m_current_dir) == "")
     {
+      /*
       if (!CmtSystem::cd (current_path))
 	{
@@ -5444,13 +5939,22 @@
 	  return;
 	}
+      */
       cmt_string project_file = "cmt";
       project_file += CmtSystem::file_separator ();
       project_file += Project::get_project_file_name ();
 
-      cmt_string pwd;
+      /*
+      cmt_string pwd (CmtSystem::pwd ());
+      cmt_string pwd_prev;
+      */
+      cmt_string dir_cur (current_path);
+      cmt_string dir_par;
+
+      cmt_string proj_file_cur;
 
       for (;;)
 	{
-	  pwd = CmtSystem::pwd ();
+	  /*
+	  //	  pwd = CmtSystem::pwd ();
 	  if (CmtSystem::test_file (project_file))
 	    {
@@ -5462,6 +5966,20 @@
 	      break;
 	    }
-
-	  log << "pwd=" << CmtSystem::pwd () << log_endl;
+	  */
+	  proj_file_cur = dir_cur;
+	  proj_file_cur += CmtSystem::file_separator ();
+	  proj_file_cur += project_file;
+	  if (CmtSystem::test_file (proj_file_cur))
+	    {
+	      //this directory should become the first entry of the CMTPATH
+
+	      IProjectFactory& factory = ProjectFactory::instance ();
+	      factory.create_project ("", dir_cur, "CurrentProject", 0);
+
+	      break;
+	    }
+
+	  /*
+	  log << "pwd=" << pwd << log_endl;
 	  
 	  if (!CmtSystem::cd (".."))
@@ -5471,13 +5989,25 @@
 	    }
 
-	  if (CmtSystem::pwd () == pwd)
+	  pwd_prev = pwd;
+	  pwd = CmtSystem::pwd ();
+	  if (pwd == pwd_prev)
+	    //	  if (CmtSystem::pwd () == pwd)
 	    {
 	      log << "Looks the same pwd..." << log_endl;
 	      break;
 	    }
-	}
-
-      CmtSystem::cd (Me.m_current_dir);
-    }
+	  */
+	  log << "dir_cur=`" << dir_cur << "'" << log_endl;
+	  CmtSystem::dirname (dir_cur, dir_par);
+	  if (dir_par == dir_cur)
+	    {
+	      log << "Looks the same dir_cur..." << log_endl;
+	      break;
+	    }
+	  dir_cur = dir_par;
+	}
+
+      //      CmtSystem::cd (Me.m_current_dir);
+    } // if (Project::find_in_cmt_paths (current_path) == "")
 
   //cmt_string buffer = "path CMTPATH \n";
@@ -5487,4 +6017,6 @@
   //  Use& use = Use::current();
 
+  bool autoconfigure_cmtpath_saved (Me.m_autoconfigure_cmtpath);
+  Me.m_autoconfigure_cmtpath = false;
   bool save_quiet = Me.m_quiet;
   Me.m_quiet = true;
@@ -5493,8 +6025,9 @@
 
   Me.m_quiet = save_quiet;
-
-  Me.m_autoconfigure_cmtpath = true;
-
-  CmtSystem::cd (here);
+  Me.m_autoconfigure_cmtpath = autoconfigure_cmtpath_saved;
+  //  Me.m_autoconfigure_cmtpath = true;
+
+  //  CmtSystem::cd (Me.m_current_dir);
+  //CmtSystem::cd (here);
 }
 
@@ -5966,8 +6499,7 @@
               fprintf (f, "endif\n");
               fprintf (f, "source ${CMTROOT}/mgr/setup.csh\n");
-              fprintf (f, "set cmt%stempfile=`${CMTROOT}/mgr/cmt -quiet build temporary_name`\n", mangled_package.c_str ());
+              fprintf (f, "set cmt%stempfile=`${CMTROOT}/${CMTBIN}/cmt.exe -quiet build temporary_name`\n", mangled_package.c_str ());
               fprintf (f, "if $status != 0 then\n  set cmt%stempfile=/tmp/cmt.$$\nendif\n", mangled_package.c_str ());
-              //fprintf (f, "${CMTROOT}/mgr/cmt setup -%s "
-              fprintf (f, "${CMTROOT}/mgr/cmt %s -%s "
+              fprintf (f, "${CMTROOT}/${CMTBIN}/cmt.exe %s -%s "
                        "-pack=%s -version=%s -path=%s %s $* >${cmt%stempfile}\n",
 		       action.c_str (),
@@ -5980,5 +6512,5 @@
 	      fprintf (f,
 		       "if ( $status != 0 ) then\n"
-		       "  echo \"${CMTROOT}/mgr/cmt %s -%s "
+		       "  echo \"${CMTROOT}/${CMTBIN}/cmt.exe %s -%s "
                        "-pack=%s -version=%s -path=%s %s $* >${cmt%stempfile}\"\n"
 		       "  set cmt%sstatus=2\n"
@@ -6026,8 +6558,7 @@
               fprintf (f, "fi\n");
               fprintf (f, ". ${CMTROOT}/mgr/setup.sh\n");
-              fprintf (f, "cmt%stempfile=`${CMTROOT}/mgr/cmt -quiet build temporary_name`\n", mangled_package.c_str ());
+              fprintf (f, "cmt%stempfile=`${CMTROOT}/${CMTBIN}/cmt.exe -quiet build temporary_name`\n", mangled_package.c_str ());
               fprintf (f, "if test ! $? = 0 ; then cmt%stempfile=/tmp/cmt.$$; fi\n", mangled_package.c_str ());
-              //fprintf (f, "${CMTROOT}/mgr/cmt setup -%s "
-              fprintf (f, "${CMTROOT}/mgr/cmt %s -%s "
+              fprintf (f, "${CMTROOT}/${CMTBIN}/cmt.exe %s -%s "
                        "-pack=%s -version=%s -path=%s %s $* >${cmt%stempfile}\n",
 		       action.c_str (),
@@ -6040,5 +6571,5 @@
               fprintf (f,
 		       "if test $? != 0 ; then\n"
-		       "  echo >&2 \"${CMTROOT}/mgr/cmt %s -%s "
+		       "  echo >&2 \"${CMTROOT}/${CMTBIN}/cmt.exe %s -%s "
                        "-pack=%s -version=%s -path=%s %s $* >${cmt%stempfile}\"\n"
 		       "  cmt%sstatus=2\n"
@@ -6074,5 +6605,4 @@
           else if (mode[i] == Bat)
             {
-              //fprintf (f, "rem Setting %s %s in %%~d0%%~p0\n",
               fprintf (f, "rem %s %s %s in %%~d0%%~p0\n",
 		       action.c_str (),
@@ -6409,5 +6939,5 @@
 
   /**
-   * See reach_current_package for an explanation of this call
+   * See apply_globals for an explanation of this call
    */
   Pattern::apply_all_globals ();
@@ -6444,5 +6974,5 @@
   Me.m_action = action_none;
 
-  restore_all_tags (0);
+  //  restore_all_tags (0);
 
 #ifdef WIN32
@@ -6481,4 +7011,10 @@
 int Cmt::parser (int argc, char* argv[])
 {
+  // save CMTFLAGS
+  cmt_string cmtflags (get_cmt_flags ());
+
+  clear ();
+  Me.initialize ();
+
   ArgParser ap (Me);
   
@@ -6493,23 +7029,38 @@
     }
 
-  // save CMTFLAGS
-  cmt_string cmtflags (get_cmt_flags ());
-
-  clear ();
+  //  clear ();
+
+  //  Me.clear ();
+
+  parse_arguments (ap);
+  // Copy ap.mode into cmt_context member/instance
+  set_print_mode (ap.mode);
 
   //  configure ();
-  configure (ap);
-
-  CmtError::clear ();
+  switch (Me.m_action)
+    {
+    case action_none :
+    case action_build_temporary_name :
+    case action_help :
+      break;
+    default:
+      configure (ap);
+      break;
+    }
+  
+  //  CmtError::clear ();
 
   /*
-    Set private if positioned inside the package
+    Set DeveloperMode if positioned inside the package
     (which is detected since we were able to retreive the
     Version, Package and Path)
   */
 
+  if (!Use::current().located ())
+  /*
   if ((Me.m_current_path.size () == 0) ||
       (Me.m_current_package.size () == 0) ||
       (Me.m_current_version.size () == 0))
+  */
     {
       Me.m_current_access = UserMode;
@@ -6520,5 +7071,5 @@
     }
   
-  parse_arguments (ap);
+  //  parse_arguments (ap);
   
   if (ap.help_action == action_help)
@@ -6826,5 +7377,5 @@
   switch (Me.m_action)
     {
-    case action_none :
+      //case action_none :
     case action_awk :
     case action_broadcast :
@@ -6929,5 +7480,6 @@
 	Me.m_warnings = false;
 	if (strlen (ap.extra_file.c_str ()) == 0)
-	  reach_current_package ();
+	  use_current_package ();
+	//	  reach_current_package ();
 	else
 	  use_extra_file (ap.extra_file);
@@ -6935,6 +7487,6 @@
 	if (strlen (ap.extra_line.c_str ()) > 0)
 	  SyntaxParser::parse_requirements_text (ap.extra_line, "extra statement(s)", (Use*) 0);
+	apply_globals ();
 	Me.m_warnings = w;
-	//if (strlen (ap.extra_line.c_str ()) > 0) SyntaxParser::parse_requirements_line (ap.extra_line, &(Use::current ()));
       }
       break;
@@ -6952,5 +7504,8 @@
   if (use != 0 && !use->discarded && !use->m_hidden && use->located ())
     uses.push_back (use);
-  uses.push_back (&(Use::current()));
+  use = &(Use::current());
+  if (use != 0 && !use->discarded && !use->m_hidden && use->located ())
+    uses.push_back (use);
+  //  uses.push_back (&(Use::current()));
   use = Use::find (CmtSystem::get_user_context_package ());
   if (use != 0 && !use->discarded && !use->m_hidden && use->located ())
@@ -7424,5 +7979,5 @@
  * joined with semi-colons to form one shell command.
  */
-void Cmt::print (PrintMode mode)
+void Cmt::print (PrintMode mode, ostream& out)
 {
   Use::UsePtrVector& Uses = Use::get_ordered_uses ();
@@ -7452,4 +8007,5 @@
   //
 
+  /*
   {
     CmtSystem::cmt_string_vector words;
@@ -7477,5 +8033,5 @@
       }
   }
-
+  */
   if (mode == Requirements)
     {
@@ -7487,5 +8043,5 @@
 	  if (tag != 0)
 	    {
-	      tag->show (true, cout, "apply_tag ");
+	      tag->show (true, out, "apply_tag ");
 	    }
 	}
@@ -7508,9 +8064,9 @@
           if (use.m_hidden) continue;
           
-          print_context (use, mode, tag);
-        }
-    }
-
-  print_context (Use::current (), mode, tag);
+          print_context (use, mode, tag, out);
+        }
+    }
+
+  print_context (Use::current (), mode, tag, out);
 
   if (Me.m_debug)
@@ -7519,5 +8075,5 @@
     }
 
-  Symbol::all_print (mode);
+  Symbol::all_print (mode, out);
   // Script::all_print (mode);
 
@@ -7532,5 +8088,5 @@
       break;
     default :
-  cout << endl;
+      out << endl;
       break;
     }
@@ -7638,5 +8194,5 @@
 
 //----------------------------------------------------------
-void Cmt::print_context (Use& use, PrintMode mode, const cmt_string& tag)
+void Cmt::print_context (Use& use, PrintMode mode, const cmt_string& tag, ostream& out)
 {
   if (use.get_package_name () == "cmt_standalone") return;
@@ -7654,4 +8210,5 @@
   switch (mode)
     {
+    case Xml :
     case Requirements :
       break;
@@ -7670,5 +8227,5 @@
       if (do_root)
 	{
-	  cout << "setenv " << prefix << "ROOT \"" <<
+	  out << "setenv " << prefix << "ROOT \"" <<
 	    use.get_full_path () << "\"" << endl;
 	}
@@ -7676,5 +8233,5 @@
       if (use.get_package_name () == "CMT")
         {
-          cout << "setenv CMTCONFIG " << system << endl;
+          out << "setenv CMTCONFIG " << system << endl;
         }
       else
@@ -7682,5 +8239,5 @@
 	  if (do_config)
 	    {
-	      cout << "setenv " << prefix << "CONFIG \"" << tag << "\"" << endl;
+	      out << "setenv " << prefix << "CONFIG \"" << tag << "\"" << endl;
 	    }
 	}
@@ -7690,5 +8247,5 @@
       if (do_root)
 	{
-	  cout << prefix << "ROOT=\"" <<
+	  out << prefix << "ROOT=\"" <<
 	    use.get_full_path () << "\"; export " <<
 	    prefix << "ROOT" << endl;
@@ -7697,5 +8254,5 @@
       if (use.get_package_name () == "CMT")
         {
-          cout << "CMTCONFIG=" << system << "; export CMTCONFIG" << endl;
+          out << "CMTCONFIG=" << system << "; export CMTCONFIG" << endl;
         }
       else
@@ -7703,5 +8260,5 @@
 	  if (do_config)
 	    {
-	      cout << prefix << "CONFIG=\"" <<
+	      out << prefix << "CONFIG=\"" <<
 		tag << "\"; export " <<
 		prefix << "CONFIG" << endl;
@@ -7713,5 +8270,5 @@
       if (do_root)
 	{
-	  cout << "set " << prefix << "ROOT=" <<
+	  out << "set " << prefix << "ROOT=" <<
 	    CmtSystem::quote (use.get_full_path (), " \t") << endl;
 	}
@@ -7719,5 +8276,5 @@
       if (use.get_package_name () == "CMT")
         {
-          cout << "set CMTCONFIG=" << system << endl;
+          out << "set CMTCONFIG=" << system << endl;
         }
       else
@@ -7725,5 +8282,5 @@
 	  if (do_config)
 	    {
-	      cout << "set " << prefix << "CONFIG=" << CmtSystem::quote (tag, " \t") << endl;
+	      out << "set " << prefix << "CONFIG=" << CmtSystem::quote (tag, " \t") << endl;
 	    }
 	}
@@ -7733,12 +8290,12 @@
       if (do_root)
 	{
-	  cout << "<variable><name>" << prefix << "ROOT</name>"
-	       << "<value>" << use.get_full_path () << "</value></variable>";
+	  out << "<variable><name>" << prefix << "ROOT</name>"
+	      << "<value>" << use.get_full_path () << "</value></variable>";
 	}
 
       if (use.get_package_name () == "CMT")
         {
-	  cout << "<variable><name>CMTCONFIG</name>"
-	       << "<value>" << system << "</value></variable>";
+	  out << "<variable><name>CMTCONFIG</name>"
+	      << "<value>" << system << "</value></variable>";
         }
       else
@@ -7746,6 +8303,6 @@
 	  if (do_config)
 	    {
-	      cout << "<variable><name>" << prefix << "CONFIG</name>"
-		   << "<value>" << tag << "</value></variable>";
+	      out << "<variable><name>" << prefix << "CONFIG</name>"
+		  << "<value>" << tag << "</value></variable>";
 	    }
 	}
@@ -7756,5 +8313,5 @@
 	  use.get_package_name () != "CMT")
 	{
-	  cout << "set " << use.prefix << "ROOT " <<
+	  out << "set " << use.prefix << "ROOT " <<
 	    CmtSystem::quote (use.get_full_path (), " \t") << endl;
 
@@ -7775,5 +8332,5 @@
       if (use.get_package_name () == "CMT")
         {
-	  cout << "set CMTCONFIG " << system << endl;
+	  out << "set CMTCONFIG " << system << endl;
         }
       else
@@ -7781,5 +8338,18 @@
 	  if (do_config)
 	    {
-	      cout << "set " << use.prefix << "CONFIG " << CmtSystem::quote (tag, " \t") << endl;
+	      out << "set " << use.prefix << "CONFIG " << CmtSystem::quote (tag, " \t") << endl;
+	      
+	      cmt_string name (use.prefix + "CONFIG");
+	      Symbol* symbol = Symbol::find (name);
+	      if (symbol != 0) 
+		{
+		  symbol->printed = true;
+		}
+	      if (symbol == 0 || symbol->type != Symbol::SymbolMacro)
+		{
+		  CmtMessage::warning
+		    (CmtError::get_error_name (CmtError::symbol_not_found)
+		     + ": macro " + name);
+		}
 	    }
 	}
@@ -7939,5 +8509,5 @@
 
 //----------------------------------------------------------
-int Cmt::reach_current_package ()
+int Cmt::use_current_package ()
 {
   Use& use = Use::current ();
@@ -7946,5 +8516,5 @@
   if (Me.m_debug)
     {
-      cout << "Cmt::reach_current_package> pwd = " 
+      cout << "Cmt::use_current_package> pwd = " 
 	   << CmtSystem::pwd () 
 	   << " path=" << Me.m_current_path
@@ -7959,10 +8529,12 @@
   if (Me.m_current_package == "cmt_standalone")
     {
-      if ((Me.m_current_path != "") && (Me.m_current_path != CmtSystem::pwd ()))
+      if ((Me.m_current_path != "") && (Me.m_current_path != Me.m_current_dir))
+//      if ((Me.m_current_path != "") && (Me.m_current_path != CmtSystem::pwd ()))
         {
           if (!CmtSystem::cd (Me.m_current_path))
             {
               CmtError::set (CmtError::package_not_found,
-                             "ReachCurrentPackage> Cannot reach the path directory");
+                             "Cannot reach the path directory: "
+			     + Me.m_current_path);
               return (0);
             }
@@ -7975,16 +8547,33 @@
 
       Me.m_current_structuring_style = without_version_directory;
+      use.structuring_style = Me.m_current_structuring_style;
+      use.change_path (Me.m_current_path, Project::get_current ());
+      Me.m_current_access = DeveloperMode;
     }
   else if (Me.m_current_package != "")
     {
-      if (!use.move_to () && !use.move_to ("", true))
-	//      if (!use.move_to ())
-        {
-          CmtError::set (CmtError::package_not_found,
-                         "ReachCurrentPackage> Cannot reach the path directory");
-          return (0);
-        }
-
-      Me.m_current_path = use.real_path;
+      if (!use.located ())
+	{
+	  //	  if (!use.move_to () && !use.move_to ("", true))
+	    //      if (!use.move_to ())
+	  if (!use.move_to ())
+	    {
+	      if (!CmtSystem::cd (Cmt::get_current_dir ()))
+		{
+		  CmtError::set (CmtError::file_access_error,
+				 Cmt::get_current_dir ()
+				 + " (use_current_package)");
+		  return 0;
+		}
+	      if (!use.move_to ("", true))
+		{
+		  CmtError::set (CmtError::package_not_found, use.get_info ());
+		  return 0;
+		}
+	    }
+	  
+	  Me.m_current_path = use.real_path;
+	  Me.m_current_access = DeveloperMode;
+	}
     }
   else
@@ -8024,5 +8613,6 @@
               
               CmtError::set (CmtError::package_not_found,
-                             "ReachCurrentPackage> Cannot reach the mgr/cmt directory");
+                             "Cannot reach the mgr/cmt directory: "
+			     + use.get_info ());
               return (0);
             }
@@ -8030,4 +8620,6 @@
       else
 	Me.m_current_style = none_style;
+
+      Me.m_current_access = DeveloperMode;
 
       dir = CmtSystem::pwd ();
@@ -8057,9 +8649,15 @@
       use.style   = Me.m_current_style;
       use.structuring_style = Me.m_current_structuring_style;
-    }
-
+
+      configure_current_dir ();
+      build_prefix (Me.m_current_package, Me.m_current_prefix);
+      build_config (Me.m_current_prefix, Me.m_current_config);
+    }
+
+  /*
   configure_current_dir ();
   build_prefix (Me.m_current_package, Me.m_current_prefix);
   build_config (Me.m_current_prefix, Me.m_current_config);
+  */
 
   /*
@@ -8067,5 +8665,5 @@
   */
 
-  if (Me.m_debug) cout << "reach_current_package0> current_tag=" << Me.m_current_tag << endl;
+  if (Me.m_debug) cout << "use_current_package0> current_tag=" << Me.m_current_tag << endl;
 
   if (Me.m_current_tag == "")
@@ -8078,9 +8676,9 @@
           Tag* tag;
 
-          tag = Tag::add (env, PriorityConfig, "reach current package", 0);
+          tag = Tag::add (env, PriorityConfig, "current package", 0);
           tag->mark (use.get_package_name ());
 	  //Me.m_current_tag = env;
 
-          //if (!Me.m_quiet) cerr << "reach_current_package1> current_tag=" << Me.m_current_tag << endl;
+          //if (!Me.m_quiet) cerr << "use_current_package1> current_tag=" << Me.m_current_tag << endl;
 
         }
